/*
=========================================================================================================
 C. Voglis, Department of Computer Science,
          Univeristy of Ioannina, Greece

 File: sample_objective.c
 Usage: The user defines his objective function!
 Last Modified: 1/12/2010
=========================================================================================================
*/
#include <math.h>

double      pi=3.14159265358979;
/*
 * =========================================================
                    Begin: Do not change
 * =========================================================
 */
 extern struct{
     int ipro;
}funcid_;

void Objective_F (double X[], int N, double *F);
void objwrap_ (double *X, int *N, double *F, int *problem)
{
      int NN;
      NN = *N;
      funcid_.ipro = *problem;
      Objective_F (X, NN, F);
}
void Objective_G (double X[], int N, double G[]);
void gradwrap_ (double *X, int *N, double *G, int *problem)
{
        int NN;
        NN = *N;
        funcid_.ipro = *problem;
        Objective_G (X, NN, G);
}
/*
 * =========================================================
                    End: Do not change
 * =========================================================
 */


double finmin ( double [], int );
double ljpot ( double );

double lj ( double p[], int n )
{
	int np, i, j, i3, j3, np1;
	double v, dx, dy, dz, rij;
	double xi, yi, zi;
	double xj, yj, zj;

	np = n/3;

	v = 0.0;
	np1 = np-1;
	for (i=0; i<np1; ++i) {
		i3 = 3*i;
		xi = p[i3];
		yi = p[i3+1];
		zi = p[i3+2];
		for (j=i+1; j<np; ++j) {
			j3 = 3*j;
			xj = p[j3];
			yj = p[j3+1];
			zj = p[j3+2];
			dx = xi-xj;
			dy = yi-yj;
			dz = zi-zj;
			rij = sqrt(dx*dx+dy*dy+dz*dz);
			v += ljpot(rij);
		}
	}
	return v;
}


#define SIGMA    1.0
#define EPSILON4 4.0
double ljpot ( double r )
{
	double sr, sr3, sr6, sr12;

	sr = SIGMA/r;
	sr3 = sr*sr*sr;
	sr6 = sr3*sr3;
	sr12 = sr6*sr6;
	return EPSILON4*(sr12-sr6);
}

void Objective_F (double X[], int N, double *F)
{
      int i;
      double sum;
      *F = lj(X, N);

}

void Bounds_F(double *xl, double *xr, int N)
{
      int i;
      for (i=0; i<N; i++)
      {
            xl[i] = -2.0;
            xr[i] = 2.0;
      }
}


