C
C =========================================================================================================
C C. Voglis, Department of Computer Science, 
C           Univeristy of Ioannina, Greece
C           
C File: objective.f 
C Usage:  Function funmin is the objective function minized by MERLIN. 
C         We provide a definition of function funmin() that call an
C         objective function wrapper written in C.
C         We also provide dummy definitions to other necessary subroutines.
C Last Modified: 1/12/2010
C =========================================================================================================
C
        function funmin(X, N)
        implicit double precision (A-H, O-Z)
        external  OBJWRAP
        common/funcid/ ipro
        dimension X(N)

        call getcnt(nf,nfp,ng,ngp,nh,nhp,nj,njp)
        if (nf.eq.1) then
                call runform(x,n)
                call setx(x)
        end if
 
         call OBJWRAP(X, N, F, ipro)
         if (nf.eq.1) call setval(F)
         funmin = F
        end

        subroutine granal(N, X, G)
        implicit double precision (A-H, O-Z)
        dimension X(N), G(N)
        external  GRADWRAP
        common/funcid/ ipro

	call gradwrap(X, N, G, ipro)

        end

        subroutine hanal()
        end
        subroutine janal()
        end
        subroutine subsum()

        end

        subroutine wunform ( x, n )
        double precision x(n)
        open (1,file='temp',form='unformatted')
        do i=1,n
          write(1) x(i)
        end do
        close (1)
        end

        subroutine runform ( x, n )
        double precision x(n)
        open (1,file='temp',form='unformatted')
        do i=1,n
          read (1) x(i)
        end do
        close (1,status='delete')
        end
