/*
=========================================================================================================
 C. Voglis, Department of Computer Science, 
 	    Univeristy of Ioannina, Greece
 	    
 File: sample_objective.c 
 Usage: The user defines his objective function!
 Last Modified: 1/12/2010
=========================================================================================================
*/
#include <math.h>

double 	pi=3.14159265358979;
/*
 * =========================================================
                    Begin: Do not change 
 * =========================================================
 */
 extern struct{
     int ipro;
}funcid_;

void Objective_F (double X[], int N, double *F);
void objwrap_ (double *X, int *N, double *F, int *problem)
{
	int NN;
	NN = *N;
	funcid_.ipro = *problem;
	Objective_F (X, NN, F);
}
void Objective_G (double X[], int N, double G[]);
void gradwrap_ (double *X, int *N, double *G, int *problem)
{
	int NN;
	NN = *N;
	funcid_.ipro = *problem;
	Objective_G (X, NN, G);
}
/*
 * =========================================================
                    End: Do not change 
 * =========================================================
 */


/*
 *
  The user must supply:
  	Objective_F (double X[], int N, double *F)	: Problem's objective function  	
  	Bounds_F(double *xl, double *xr, int N)		: Problem's bounds
  
  Also one can supply a subroutine for first order derivative 
  	Objective_G (double X[], int N, double G[])	: Objective function's derivative 
 *
 */

/*
 *
  -------------------------------------------
  N-dimensional Rastrigin objective function: 
  -------------------------------------------
  	Global minimum	: [0, 0, ..., 0]^N
  	Value	  	: 0.0	
 *
 */ 
void Objective_F (double X[], int N, double *F)
{
	int i;
	double sum;
	*F = 0;
	for (i=0; i<N; i++)
		*F = *F + pow(X[i],2) + 10.0 - 10.0*cos(2*pi*X[i]);
	
}

void Bounds_F(double *xl, double *xr, int N)
{
	int i;
	for (i=0; i<N; i++)
	{
		xl[i] = -5.12;
		xr[i] = 5.12;
	}
}


void Objective_G (double X[], int N, double G[])
{
	int i;
	double sum;
	for (i=0; i<N; i++)
		G[i] = 0.0;

	for (i=0; i<N; i++)
		G[i] = G[i] + 2.0*X[i] + 20.0*pi*sin(2*pi*X[i]);
}

