/*
=========================================================================================================
 C. Voglis, Department of Computer Science, 
 	    Univeristy of Ioannina, Greece
 	    
 File: sample_objective.c 
 Usage: The user defines his objective function!
 Last Modified: 1/12/2010
=========================================================================================================
*/
#include <math.h>
#include <stdio.h>

double 	pi=3.14159265358979;
/*
 * =========================================================
                    Begin: Do not change 
 * =========================================================
 */
 extern struct{
     int ipro;
}funcid_;

void Objective_F (double X[], int N, double *F);
void objwrap_ (double *X, int *N, double *F, int *problem)
{
	int NN;
	NN = *N;
	funcid_.ipro = *problem;
	Objective_F (X, NN, F);
}
void Objective_G (double X[], int N, double G[]);
void gradwrap_ (double *X, int *N, double *G, int *problem)
{
	int NN;
	NN = *N;
	funcid_.ipro = *problem;
	Objective_G (X, NN, G);
}
/*
 * =========================================================
                    End: Do not change 
 * =========================================================
 */


/*
 *
  The user must supply:
  	Objective_F (double X[], int N, double *F)	: Problem's objective function  	
  	Bounds_F(double *xl, double *xr, int N)		: Problem's bounds
  
  Also one can supply a subroutine for first order derivative 
  	Objective_G (double X[], int N, double G[])	: Objective function's derivative 
 *
 */


 /*
  -------------------------------------------
  N-dimensional Rastrigin objective function: 
  -------------------------------------------
  	Global minimum	: [0, 0, ..., 0]^N
  	Value	  	: 0.0	
 *
 */ 
void Objective_F (double X[], int N, double *F)
{
	int i;
	double x[101], y[101], fit[101];
	double sum;
	*F = 0;
	FILE *fid;
	
	fid = fopen("data.txt", "r");
	for (i=0; i<101; i++)
	{
		fscanf(fid, "%lf %lf\n", &x[i], &y[i]);	
	}
	fclose(fid);	

	for (i=0;i<101;i++)
	{
		fit[i] = X[0]*exp(-(x[i]-X[1])*(x[i]-X[1])/X[2]) +  X[3]*exp(-(x[i]-X[4])*(x[i]-X[4])/X[5]) + X[6]*exp(-(x[i]-X[7])*(x[i]-X[7])/X[8]); 	
		*F = *F  + (fit[i] - y[i])*(fit[i] - y[i]);
	}
	*F = *F / 101.0;
	
}

void Bounds_F(double *xl, double *xr, int N)
{
	int i;
	for (i=0; i<N; i++)
	{
		xl[i] = 0.0;
		xr[i] = 10.0;
	}
	xl[2] = 0.01;
	xl[5] = 0.01;
	xl[8] = 0.01;
	
}


