#include <stdio.h>
#include <stdlib.h>

#include "mempsode.h"

int main(int argc, char **argv)
{
	int i, id;
	double val, point[1000];
	FILE *fp;
	

	init_mempsode();
	set_mempsode_iparam("algorithm", 1);
	set_mempsode_iparam("dimension", 9);
	set_mempsode_iparam("swarm-size", 100);
	set_mempsode_iparam("max-fun-evals", 50000);
	set_mempsode_iparam("dump-iterations", 0);
	set_mempsode_iparam("memetic", 0);
	set_mempsode_iparam("seed", 1);

	mempsode();

	get_mempsode_min("minval", &val);
	get_mempsode_min("minx", point);
    	printf("Val -->%f \n",  val);
	for (i=0; i<prob.dim; i++)
		printf("X(%i)=%f\n", i, point[i]);

	fp = fopen("plot.in", "w");
	if (fp!=NULL)
	{
		fprintf(fp, "set term post \n");
		fprintf(fp, "set output 'fit.eps' \n");
		fprintf(fp, "plot %.2f*exp(-(x-%.2f)**2/%.2f)+ %.2f*exp(-(x-%.2f)**2/%.2f)+%.2f*exp(-(x-%.2f)**2/%.2f), 'data.txt' with points \n", 
		             point[0], point[1], point[2], point[3], point[4], point[5], point[6], point[7], point[8]);
	}
	fclose(fp);
}
